Description

Supportanfrage

we notice that in ADTF2 we can use "CopyBufferTo" to copy a sample stream to a buffer, is there same function or similar thing in

ADTF3?

Our goal is to sample all the streams coming from input pins to a buffer.

Thanks in advance!

Lösung

The equivalent to CopyToBuffer in ADTF 3 is

    object_ptr<const ISample> pSample;

    object_ptr_locked<const ISampleBuffer> pBuffer;

    RETURN_IF_FAILED(pSample->Lock(pBuffer));

    memcpy(pDest, pBuffer->GetPtr(),  std::min(nDestSize, pBuffer->GetSize()));

History

#1 - 2020-04-23 17:48 - hidden

- Project changed from Public Support to 11

- Status changed from New to In Progress

- Topic set to ADTF::SDK

- Customer set to AUDI

- Department set to EF

#3 - 2020-04-24 10:15 - hidden

Hi Martin,

we would like to provide more information on this.

Our assumption:

1.      To copy streams to a buffer, we need to give the size. Therefore first we need to get the size of a struct based on DDL. Is that correct?

2.      If first assumption is correct, how do we get the size of a struct based on a DDL file? We noticed that in the demo “demo_md_data_generator”,

function “create_adtf_default_stream_type_from_service” is used to get pType of a user specified structure. So we used this function, and print the

size of this pType. However it always gives the same size no matter which struct name we gave.

3.      Could you please tell us whether our assumption is correct and how can we obtain the size of a struct based on DDL ?

Thanks a lot!

Best regards,
Xinjie

#4 - 2020-04-30 09:37 - hidden

Hi Xinjie,

I'm not sure I'm understanding you correctly, but the equivalent to CopyToBuffer in ADTF 3 is

    object_ptr<const ISample> pSample;

    object_ptr_locked<const ISampleBuffer> pBuffer;

    RETURN_IF_FAILED(pSample->Lock(pBuffer));

    memcpy(pDest, pBuffer->GetPtr(),  std::min(nDestSize, pBuffer->GetSize()));

 Regards,

Martin

#6 - 2020-04-30 09:46 - hidden

In addition to all other comments:

@Xinjie/Faisal: Are #11131 and #11090 the same issue ?

#7 - 2020-04-30 10:15 - hidden

Hello Florian,

Not entirely, but they can perhaps be treated similar, because Issue #11090 was one part of the #Issue 11131.

The previous Copy buffer problem was solved by using oCoder and ddl::Serialization::transform() Funktion.

VG

Faisal

#8 - 2020-05-04 11:54 - hidden

- Status changed from In Progress to Customer Feedback Required

OK... so any feedback to #11090#note-4 ?

#9 - 2020-05-07 13:30 - hidden

Hallo Florian,

sorry für eine spätere Antwort. Bzgl. #11090#note-4 haben wir zurzeit eine andere Lösung mit cSampleDecoder und

ddl::serialization::transform(oDecoder, oCoder)benutzt, um die Stream Inhalte in einem Buffer zu kopieren, wo wir ein Buffer mit oCoder hinzufügt

haben. Und es scheint soweit zu funktionieren.

Danke für eure Support. ☺

Viele Grüße

Faisal

#10 - 2020-05-07 14:04 - hidden

- Subject changed from Buffer Problem to Copy a sample stream to a buffer

- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Resolution set to Solved Issue

#13 - 2020-07-07 13:29 - hidden

- Project changed from 11 to Public Support

#14 - 2020-07-07 13:30 - hidden

- Private changed from Yes to No

#15 - 2020-07-07 16:41 - hidden

- Status changed from To Be Closed to Closed
